//+------------------------------------------------------------------+
//|                                                     JoGET_MA.mq4 |
//|                                        Copyright  2008, masemus |
//|                                                 Gresik@Indonesia |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, masemus"
#property link      "Gresik@Indonesia"

#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 White
#property indicator_color2 DeepPink
#property indicator_color3 White
#property indicator_color4 DodgerBlue
#property indicator_color5 Lime
#property indicator_color6 Red
#property indicator_color7 Blue
#property indicator_color8 Yellow
extern int TF = 0;
extern bool Show_Arrow1 = false; 
extern bool Show_Arrow2 = false; 

//---- input parameters
extern int MA1_periode = 4;
extern int MA1_shift = 0;
extern int MA1_mode = 0;
extern int MA1_price_type = 0;

extern int MA2_periode = 4;
extern int MA2_shift = 0;
extern int MA2_mode = 0;
extern int MA2_price_type = 1;

extern int MA3_periode = 20;
extern int MA3_shift = 0;
extern int MA3_mode = 0;
extern int MA3_price_type = 0;

extern int MA4_periode = 20;
extern int MA4_shift = 0;
extern int MA4_mode = 0;
extern int MA4_price_type = 1;

//---- buffers
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double ExtBuffer4[];
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];

string TimeFrameStr;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

  // IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexStyle(3,DRAW_LINE,0,2);
   SetIndexBuffer(3,ExtBuffer4);

   SetIndexStyle(4,DRAW_ARROW,EMPTY);
   SetIndexStyle(5,DRAW_ARROW,EMPTY);
   SetIndexStyle(6,DRAW_ARROW,EMPTY,2);
   SetIndexStyle(7,DRAW_ARROW,EMPTY,2);
  
   SetIndexBuffer(4,UpBuffer1);
   SetIndexBuffer(5,DnBuffer1);
   SetIndexBuffer(6,UpBuffer2);
   SetIndexBuffer(7,DnBuffer2);
  
   SetIndexArrow(4,233);
   SetIndexArrow(5,234);
   SetIndexArrow(6,233);
   SetIndexArrow(7,234);

switch(TF)
   {
      case 1 : TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe"; TF=0;
   }
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
  
   for(int i = 0 ;i < limit ;i++)
   { 
      double pMA1 = iMA(NULL,TF,MA1_periode,MA1_shift,MA1_mode,MA1_price_type,i+1);
      double cMA1 = iMA(NULL,TF,MA1_periode,MA1_shift,MA1_mode,MA1_price_type,i);
      double pMA2 = iMA(NULL,TF,MA2_periode,MA2_shift,MA2_mode,MA2_price_type,i+1);
      double cMA2 = iMA(NULL,TF,MA2_periode,MA2_shift,MA2_mode,MA2_price_type,i);
      double pMA3 = iMA(NULL,TF,MA3_periode,MA3_shift,MA3_mode,MA3_price_type,i+1);
      double cMA3 = iMA(NULL,TF,MA3_periode,MA3_shift,MA3_mode,MA3_price_type,i);
      double pMA4 = iMA(NULL,TF,MA4_periode,MA4_shift,MA4_mode,MA4_price_type,i+1);
      double cMA4 = iMA(NULL,TF,MA4_periode,MA4_shift,MA4_mode,MA4_price_type,i);
      
      ExtBuffer1[i] = cMA1;
      ExtBuffer2[i] = cMA2;
      ExtBuffer3[i] = cMA3;
      ExtBuffer4[i] = cMA4;

      if(Show_Arrow1==true)
      if((cMA1 > cMA2) && (pMA1 <= pMA2))
      {  
        UpBuffer1[i] = iLow(Symbol(),TF,i)-(3*Point);
        DnBuffer1[i] = EMPTY_VALUE;
      }
      else if((pMA1 >= pMA2) && (cMA1 < cMA2))
      {
        UpBuffer1[i] = EMPTY_VALUE;
        DnBuffer1[i] = iHigh(Symbol(),TF,i)+(3*Point);
      }
      else
      {
        UpBuffer1[i] = EMPTY_VALUE;
        DnBuffer1[i] = EMPTY_VALUE;
      }
      
      if(Show_Arrow2==true)
      if ((cMA3 > cMA4) && (pMA3 <= pMA4))
      {  
        UpBuffer2[i] = iLow(Symbol(),TF,i)-(3*Point);
        DnBuffer2[i] =  EMPTY_VALUE;
      }
      else if((cMA3 < cMA4) && (pMA3 >= pMA4))
      {
        UpBuffer2[i] = EMPTY_VALUE;
        DnBuffer2[i] = iHigh(Symbol(),TF,i)+(3*Point);
      }
      else
      {
        UpBuffer2[i] = EMPTY_VALUE;
        DnBuffer2[i] = EMPTY_VALUE;
      }
   }
//----

   return(0);
  }
//+------------------------------------------------------------------+



